import type { AppRouteModule } from '/@/router/types'
import { LAYOUT } from '/@/router/constant'

const rpcshell: AppRouteModule = {
    path: '/rpcshell',
    name: 'rpcshell',
    component: LAYOUT,
    redirect: '/rpcshell/index',
    meta: {
        orderNo: 6,
        hideChildrenInMenu: true,
        icon: 'ant-design:api-outlined',
        title: 'RPC控制台',
    },
    children: [
        {
            path: 'index',
            name: 'RPC控制台',
            component: () => import('/@/views/rpc-shell/src/SimplePanel.vue'),
            meta: {
                title: 'RPC控制台',
            },
        },
    ],
}

export default rpcshell
