import type { AppRouteModule } from '/@/router/types'

import { LAYOUT } from '/@/router/constant'

const userManager: AppRouteModule = {
    path: '/UserManger',
    name: 'UserMangerDemo',
    component: LAYOUT,
    redirect: '/userManger/index',
    meta: {
        orderNo: 2,
        hideChildrenInMenu: true,
        icon: 'ant-design:user-outlined',
        title: '用户管理',
    },
    children: [
        {
            path: 'index',
            name: 'UserMangerDemo',
            component: () => import('/@/views/sys/user_manager/user_manager.vue'),
            meta: {
                title: 'UserManger',
                icon: 'ant-design:user-outlined',
                hideMenu: true,
            },
        },
    ],
}

export default userManager