import type { AppRouteModule } from '/@/router/types'

import { LAYOUT } from '/@/router/constant'

const userManager: AppRouteModule = {
  path: '/VMManager',
  name: 'VMManagerDemo',
  component: LAYOUT,
  redirect: '/vmManager/index',
  meta: {
    orderNo: 4,
    hideChildrenInMenu: true,
    icon: 'ant-design:cloud-server-outlined',
    title: '实时信息',
  },
  children: [
    {
      path: 'index',
      name: 'VMManagerDemo',
      component: () => import('/@/views/sys/vm_manager/vm_manager.vue'),
      meta: {
        title: 'VMManager',
        icon: 'ant-design:cloud-server-outlined',
        hideMenu: true,
      },
    },
  ],
}

export default userManager