
import { BonBuffer } from "../../net/serialization/bon";
import { addToMeta, removeFromMeta, Struct, notifyModify, StructMgr, structMgr} from "../../net/serialization/struct_mgr";
import { StructInfo, Type, FieldInfo, EnumType, EnumInfo} from "../../net/serialization/sinfo";
export class DelayMessage extends Struct {

    key: number;
    msg: string;
    gid: number;
    mtype: number;
    createtime: number;
    pubtime: number;
    uids: Array<number>;
    annex: string;
	static _$info =  new StructInfo("management_page/server/db/special_msg.DelayMessage",1835668712,  new Map( [["primary","key"],["db","logfile"]]), [new FieldInfo("key", 
new EnumType( Type.U32 ), null), new FieldInfo("msg", 
new EnumType( Type.Str ), null), new FieldInfo("gid", 
new EnumType( Type.U32 ), null), new FieldInfo("mtype", 
new EnumType( Type.U32 ), null), new FieldInfo("createtime", 
new EnumType( Type.Usize ), null), new FieldInfo("pubtime", 
new EnumType( Type.Usize ), null), new FieldInfo("uids", 
new EnumType( Type.Arr, 
new EnumType( Type.U32 ) ), null), new FieldInfo("annex", 
new EnumType( Type.Str ), null) ]);


	addMeta(mgr: StructMgr){
		if(this._$meta)
			return;
		addToMeta(mgr, this);
	}

	removeMeta(){
		removeFromMeta(this);
	}



	
	static bonType(): number {
		return DelayMessage._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): DelayMessage {
		let o;
		o = new DelayMessage();

		o.key = bb.readInt();
		o.msg = bb.readUtf8();
		o.gid = bb.readInt();
		o.mtype = bb.readInt();
		o.createtime = bb.readInt();
		o.pubtime = bb.readInt();
		o.uids = bb.readArray(() => {
	return     bb.readInt();
})
;
		o.annex = bb.readUtf8();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeInt(this.key);
                
        bb.writeUtf8(this.msg);
                
        bb.writeInt(this.gid);
                
        bb.writeInt(this.mtype);
                
        bb.writeInt(this.createtime);
                
        bb.writeInt(this.pubtime);
                
        bb.writeArray(this.uids, (el) => {    
            bb.writeInt(el);
            
        });
                
        bb.writeUtf8(this.annex);
        
		return bb;
	}
    }
    structMgr.register(DelayMessage._$info.name_hash, DelayMessage, DelayMessage._$info.name);


export class DelayMsgID extends Struct {

    key: string;
    id: number;
	static _$info =  new StructInfo("management_page/server/db/special_msg.DelayMsgID",4019509681,  new Map( [["primary","key"],["db","logfile"]]), [new FieldInfo("key", 
new EnumType( Type.Str ), null), new FieldInfo("id", 
new EnumType( Type.U32 ), null) ]);


	addMeta(mgr: StructMgr){
		if(this._$meta)
			return;
		addToMeta(mgr, this);
	}

	removeMeta(){
		removeFromMeta(this);
	}



	
	static bonType(): number {
		return DelayMsgID._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): DelayMsgID {
		let o;
		o = new DelayMsgID();

		o.key = bb.readUtf8();
		o.id = bb.readInt();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.key);
                
        bb.writeInt(this.id);
        
		return bb;
	}
    }
    structMgr.register(DelayMsgID._$info.name_hash, DelayMsgID, DelayMsgID._$info.name);

