// 在这里设置环境信息 - 通用1
//#region
window.winit = {};
var debug = true;
window.debug = debug;

if (!debug) {
    console.log = function () { };
}

winit.env = {
    debug: debug,
    log: // 定义每模块的日志等级， debug:1 info:2 warn:3
    {
        'pi/**': 2,
        'app/**': 1
    },
    exe: window.piAssetsPath !== undefined,
    platform: {}
};

// ======== 判断平台版本
var env = winit.env;
//#endregion

// 项目 - 通用
//#region

var project = {
    /**
     * @TODO !!!每个项目必须定义自己的名称，该名称决定了访问二级域名和本地存储名
     */
    name: 'pi_demo',
    version_no: '1.0.4',
    // 全局错误捕捉，记录次数后发送到服务器上
    catch: true,
    /**
     * @TODO
     */
    app_id: "pi_demo",
};

Object.assign(
    winit.env,
    project
);

//#endregion

// GUI - 通用
//#region 
window["__isNew"] = true;

var gui = {
    img_zoom: 1,
    /**
     * @TODO
     */
    design_size: {
        width: 3360,
        height: 2360
    },
    max_extend: 10,
    gpu_performance: 1,
    rotate_fit: true,
    compressed_tex_formats: [],
    img_zoom_options: [1.0],
    // show_rect: {top: 0, left: 0, bottom:0, right: 0}, // 显示区域，该选项可选，默认为设备的安全区域
};

Object.assign(
    winit.env,
    gui
);
//#endregion

// 资源 - 通用
//#region
var res = {
    root_path: // 文件的根路径
        '/',
    batch_path: // 批下载的路径
        '/batch?',
    start_time: // 启动时间
        Date.now(),
    code_suffixs: // 代码的后缀
        [],
    cfg_suffixs: // 配置的后缀
        [
            'widcfg', 'dcss', 'kcss', 'imgcfg', 'jcfg'
        ],
    res_suffixs: // 资源的后缀
        [
            'wasm', 'rjson', 'atlas', 'webp', 'gif', 'svg', 'gltf', 'ani', 'bin', "geo", "mgeo", "sklai"
        ],
    obj_suffixs: // 资源对象的后缀
        [
            'png', 'jpg', 'jpeg', 'wav', 'mp3', 'aac', 'webm', 'mp4', 'ogg', 'm3u8', 'ttf', 'TTF', 'otf', 'woff', 'woff2'
        ],

    res_timeout: 10, // 资源的超时时间，单位：秒
    res_cache_size: 512 * 1024, // 每个 资源 缓存的内存大小
    imm_load_suffixs: [], // 需要立即加载的imm后缀，底层已经默认加了 "struct"
};

Object.assign(
    winit.env,
    res
);

// 版本文件的路径
// env.version_path = (debug ? "es6" : "es6.min") + ".version";
env.version_path = "game.version";

// 底层宿主平台；
env.user_agent = navigator.userAgent;

// pi_sys, webview版本使用：获取asset包depend的路径；
env.mobile_asset_path = "dst";

// pi_sys, webview版本使用：获取asset包depend的路径；
// env.asset_depend_path = (debug ? "es6" : "es6.min") + ".depend";
env.asset_depend_path = (debug ? "es6" : "es6.min") + ".depend";

//#endregion

// 分包或文件夹加载配置 - 通用
//#region
var packageEnv = {
    /**
     * @TODO 起始加载的分包目录
     */
    load: [
        'pi_gui/',
        'pi_utils/',
        'psd/',
    ],
    /**
     * @TODO 加载完毕后执行的模块、方法和参数(注册widget， 初始化gui引擎)
     */
    exec: [
        [
            'pi_utils/main', 'init_pi_utils'
        ],
        [
            'pi_gui/main', 'init', window.canvas, 1024 * 1024 * 30
        ]
    ],
    /**
     * @TODO 继续加载的代码模块
     */
    next_load: [
        'pi_common/',
        'pi_pt/',
        'management_page/',
        'font/'
    ],
    /**
     * @TODO 继续加载完毕后执行的模块、方法和参数
     */
    next_exec: [
        [
            'management_page/util/setup', 'init'
        ]
    ],
    /**
     * @TODO 代码层控制的后续加载
     */
    last_load: [
        'app_b/',
        'app_c/'
    ]
};

Object.assign(
    winit.env,
    packageEnv
);

// 非小游戏平台会用这个接口
// 在 html 中会调用
const testBenchLevel = () => {
    return new Promise((resolve, reject) => {
        let worker = new Worker('./worker.js');
        if (!worker) {
            reject({
                cpu: {
                    count: -1,
                    time: -1,
                },
                memory: {
                    count: -1,
                    time: -1,
                }
            });
            return;
        }

        worker.postMessage("run");

        worker.onmessage = function (e) {
            worker.terminate();
            resolve(e.data);
        }

        worker.onerror = function () {
            reject({
                cpu: {
                    count: -1,
                    time: -1,
                },
                memory: {
                    count: -1,
                    time: -1,
                }
            });
        }
    });
}

//#endregion