import type { AppRouteModule } from '/@/router/types'
import { LAYOUT } from '/@/router/constant'

const webshell: AppRouteModule = {
    path: '/webshell',
    name: 'webshell',
    component: LAYOUT,
    redirect: '/webshell/index',
    meta: {
        orderNo: 5,
        icon: 'ant-design:partition-outlined',
        hideChildrenInMenu: true,
        title: '后端控制台',
    },
    children: [
        {
            path: 'index',
            name: '后端控制台',
            component: () => import('/@/views/web-shell/SimplePanel.vue'),
            meta: {
                title: '后端控制台',
            },
        },
    ],
}

export default webshell
